//-----------------------------------------------------------------------------
// JPEGNbNۑvOC
//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <sys/time.h>
#include <jpeglib.h>

#include "filter.h"
#include "jpeg_print.h"
#include "quant_tbl.h"
#include "jpeg_3ten.h"

#define PRINT_BUTTON_WIDTH      180
#define CONFIG_BUTTON_WIDTH     64
#define CLIENT_WIDTH            (PRINT_BUTTON_WIDTH + CONFIG_BUTTON_WIDTH)
#define CLIENT_HEIGHT           32

HWND g_hdlg = NULL;
static HINSTANCE g_dll_hinst = NULL;
static char g_filter_name[FILENAME_MAX * 2 +1] = "JPEGNbNۑ"; // vOC̖Oiz̃TCY͑傫߁j
static char g_config_caption[FILENAME_MAX * 2 +1] = "JPEGۑݒ"; // ݒ_CAÕLvV

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
    FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_MAIN_MESSAGE|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_DISP_FILTER,
    CLIENT_WIDTH + 16, CLIENT_HEIGHT + 32,
    (TCHAR *)g_filter_name,
    0,NULL,NULL,
    NULL,NULL,
    0,NULL,NULL,
    NULL,
    func_init,
    NULL,
    NULL,
    func_WndProc,
    NULL,NULL,
    NULL,
    0,
    (TCHAR*)"JPEGNbNۑ " JPEG_3TEN_VERSION,
    NULL,NULL,
    NULL,NULL,NULL,NULL,
    NULL,
};


//---------------------------------------------------------------------
// ݒϐ
//---------------------------------------------------------------------
typedef struct {
    TCHAR path[MAX_PATH];
    int qualty;
    int optimize;
    int progression;
    int downsampling;
    int quantize;
    int beep;
    int colormatrix;
    int chroma_offset;
    int progression_mine;
} CONFIG;
static CONFIG config = { "", 90, 1, 1, 2, 0, 1, 0, 0, 0 };

//---------------------------------------------------------------------
// DLLMain
// ʏ̃tB^Ȃ炢ȂAHINSTANCE擾邽߂ɗp
//---------------------------------------------------------------------
EXTERN_C WINAPI __declspec(dllexport) BOOL __stdcall DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    g_dll_hinst = hinstDLL;
    return TRUE;
}

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    char filename[FILENAME_MAX*2+1];
    char str[1024 + sizeof(g_filter_name) + sizeof(filename)]; // 傫߂Ɋm

    if( g_dll_hinst && GetModuleFileName( g_dll_hinst, str, sizeof(str) ) )
    {
        // t@C擾
        _splitpath( str, NULL, NULL, filename, NULL );

        // filenameɖ肪肻ȕꍇ͉Ȃ
        int len = strlen( filename );
        for( int i = 0; i < len; i++ )
        {
            char c = filename[i];
            if( c < 32 || c >= 127 ) return &filter;
        }

        // ftHg̖OƈtB^[ȂǂύX
        if( len > 0 && strcmp( filename, "jpeg_print" ) )
        {
            // tB^[
            strncpy( g_filter_name, "JPEGNbNۑ(", sizeof(g_filter_name) );
            strncat( g_filter_name, filename, sizeof(filename) );
            strncat( g_filter_name, ")", 1 );
            g_filter_name[sizeof(g_filter_name)-1] = '\0'; // Ô
            filter.name = (TCHAR *)g_filter_name;

            // ݒ_CAÕLvV
            strncpy( g_config_caption, "JPEGۑݒ(", sizeof(g_config_caption) );
            strncat( g_config_caption, filename, sizeof(filename) );
            strncat( g_config_caption, ")", 1 );
            g_config_caption[sizeof(g_config_caption)-1] = '\0'; // Ô
        }
    }

    return &filter;
}

//---------------------------------------------------------------------
// 
//---------------------------------------------------------------------
BOOL func_init( FILTER *fp )
{
    if( fp->exfunc->add_menu_item )
    {
        // AviUtl̃j[ɒǉ
        fp->exfunc->add_menu_item( fp, (LPSTR)"݂̃t[JPEGۑ", fp->hwnd, IDC_PRINT, 0, 0 );
        fp->exfunc->add_menu_item( fp, (LPSTR)"ݒ", fp->hwnd, IDC_CONFIG, 0, 0 );
    }
    return TRUE;
}


//---------------------------------------------------------------------
// jpeg̃G[
// {ȂvZXIƂ낾A
// AviUtlނ̂͂Ȃ̂ŁA
// G[m؂̏֎~悤ɂB
//---------------------------------------------------------------------
static BOOL NoErr = TRUE; // G[ĂȂTRUE

void my_error_exit( j_common_ptr cinfo )
{
    NoErr = FALSE;
}

//---------------------------------------------------------------------
// vObVuJPEG̐ݒJX^}CY
// jcparam.c̃R[hɂĂ
//---------------------------------------------------------------------
jpeg_scan_info * fill_a_scan( jpeg_scan_info * scanptr, int ci, int Ss, int Se, int Ah, int Al )
{
    scanptr->comps_in_scan = 1;
    scanptr->component_index[0] = ci;
    scanptr->Ss = Ss;
    scanptr->Se = Se;
    scanptr->Ah = Ah;
    scanptr->Al = Al;
    scanptr++;
    return scanptr;
}

jpeg_scan_info * fill_scans( jpeg_scan_info * scanptr, int ncomps, int Ss, int Se, int Ah, int Al )
{
    int ci;

    for( ci = 0; ci < ncomps; ci++ )
    {
        scanptr->comps_in_scan = 1;
        scanptr->component_index[0] = ci;
        scanptr->Ss = Ss;
        scanptr->Se = Se;
        scanptr->Ah = Ah;
        scanptr->Al = Al;
        scanptr++;
    }
    return scanptr;
}

jpeg_scan_info * fill_dc_scans( jpeg_scan_info * scanptr, int ncomps, int Ah, int Al )
{
    int ci;

    if( ncomps <= MAX_COMPS_IN_SCAN )
    {
        scanptr->comps_in_scan = ncomps;
        for( ci = 0; ci < ncomps; ci++ ) scanptr->component_index[ci] = ci;
        scanptr->Ss = scanptr->Se = 0;
        scanptr->Ah = Ah;
        scanptr->Al = Al;
        scanptr++;
    }
    else
    {
        scanptr = fill_scans(scanptr, ncomps, 0, 0, Ah, Al);
    }
    return scanptr;
}

void my_jpeg_progression( j_compress_ptr cinfo, int mode )
{
    int ncomps = cinfo->num_components;
    int nscans;
    jpeg_scan_info * scanptr;

    if( ncomps == 3 && cinfo->jpeg_color_space == JCS_YCbCr )
    {
        if( mode == 0 )
            nscans = 8;
        else if( mode == 2 )
            nscans = 12;
        else
            nscans = 11;
    }
    else
    {
        if( mode == 0 )
            nscans = 4 * ncomps;
        else if( mode == 2 )
            nscans = 6 * ncomps;
        else
            nscans = 5 * ncomps;
    }

    if( cinfo->script_space == NULL || cinfo->script_space_size < nscans )
    {
        cinfo->script_space_size = (nscans > 10) ? nscans : 10;
        cinfo->script_space =
            (jpeg_scan_info *) (*cinfo->mem->alloc_small) (
                (j_common_ptr) cinfo,
                JPOOL_PERMANENT,
                cinfo->script_space_size * ((size_t) sizeof(jpeg_scan_info))
            );
    }
    scanptr = cinfo->script_space;
    cinfo->scan_info = scanptr;
    cinfo->num_scans = nscans;

    if( ncomps == 3 && cinfo->jpeg_color_space == JCS_YCbCr )
    {
        if( mode == 0 )
        {
            scanptr = fill_a_scan(scanptr, 0, 0,  0, 0, 0); // Y :ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 0, 1,  5, 0, 1); // Y :ʎqW1`5ԖځB1bitbitH
            scanptr = fill_a_scan(scanptr, 0, 6, 63, 0, 1); // Y :ʎqW6`63ԖځB1bitbitH
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 1, 0); // Y :ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 2, 0,  0, 0, 0); // Cr:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 2, 1, 63, 0, 0); // Cr:ʎqW1`63ԖځBSbit
            scanptr = fill_a_scan(scanptr, 1, 0,  0, 0, 0); // Cb:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 1, 1, 63, 0, 0); // Cb:ʎqW1`63ԖځBSbit
        }
        else if( mode == 2 )
        {
            scanptr = fill_a_scan(scanptr, 0, 0,  0, 0, 0); // Y :ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 0, 1,  5, 0, 3); // Y :ʎqW1`5ԖځB3bitbitH
            scanptr = fill_a_scan(scanptr, 0, 6, 63, 0, 3); // Y :ʎqW6`63ԖځB3bitbitH
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 3, 2); // Y :ʎqW1`63ԖځBǉ1bit
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 2, 1); // Y :ʎqW1`63ԖځBǉ1bit
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 1, 0); // Y :ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 2, 0,  0, 0, 0); // Cr:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 2, 1, 63, 1, 0); // Cr:ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 2, 1, 63, 0, 1); // Cr:ʎqW1`63ԖځB1bitbitH
            scanptr = fill_a_scan(scanptr, 1, 0,  0, 0, 0); // Cb:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 1, 1, 63, 1, 0); // Cb:ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 1, 1, 63, 0, 1); // Cb:ʎqW1`63ԖځB1bitbitH
        }
        else // if( mode == 1 )
        {
            scanptr = fill_a_scan(scanptr, 0, 0,  0, 0, 0); // Y :ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 0, 1,  5, 0, 2); // Y :ʎqW1`5ԖځB2bitbitH
            scanptr = fill_a_scan(scanptr, 0, 6, 63, 0, 2); // Y :ʎqW6`63ԖځB2bitbitH
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 2, 1); // Y :ʎqW1`63ԖځBǉ1bit
            scanptr = fill_a_scan(scanptr, 0, 1, 63, 1, 0); // Y :ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 2, 0,  0, 0, 0); // Cr:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 2, 1, 63, 0, 1); // Cr:ʎqW1`63ԖځB1bitbitH
            scanptr = fill_a_scan(scanptr, 2, 1, 63, 1, 0); // Cr:ʎqW1`63ԖځBcbit
            scanptr = fill_a_scan(scanptr, 1, 0,  0, 0, 0); // Cb:ʎqW0Ԗ(DC)BSbit
            scanptr = fill_a_scan(scanptr, 1, 1, 63, 0, 1); // Cb:ʎqW1`63ԖځB1bitbitH
            scanptr = fill_a_scan(scanptr, 1, 1, 63, 1, 0); // Cb:ʎqW1`63ԖځBcbit
        }
    }
    else
    {
        if( mode == 0 )
        {
            scanptr = fill_scans(scanptr, ncomps, 0,  0, 0, 0);
            scanptr = fill_scans(scanptr, ncomps, 1,  5, 0, 1);
            scanptr = fill_scans(scanptr, ncomps, 6, 63, 0, 1);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 1, 0);
        }
        else if( mode == 2 )
        {
            scanptr = fill_scans(scanptr, ncomps, 0,  0, 0, 0);
            scanptr = fill_scans(scanptr, ncomps, 1,  5, 0, 3);
            scanptr = fill_scans(scanptr, ncomps, 6, 63, 0, 3);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 3, 2);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 2, 1);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 1, 0);
        }
        else // if( mode == 1 )
        {
            scanptr = fill_scans(scanptr, ncomps, 0,  0, 0, 0);
            scanptr = fill_scans(scanptr, ncomps, 1,  5, 0, 2);
            scanptr = fill_scans(scanptr, ncomps, 6, 63, 0, 2);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 2, 1);
            scanptr = fill_scans(scanptr, ncomps, 1, 63, 1, 0);
        }
    }
}

//---------------------------------------------------------------------
// cinfoɓo^Ăʎqe[u]֐
//---------------------------------------------------------------------
float my_jpeg_quant_rate( j_compress_ptr cinfo )
{
    JQUANT_TBL *tblptr = cinfo->quant_tbl_ptrs[0];
    if( tblptr == NULL ) return 352.0; // ȒliftHg̒ljɂĂ

    UINT16 *quants = tblptr->quantval;
    double sum = 0.0;
    for( int i = 0; i < 64; i++ ) sum += log2( (double)quants[i] );

    return (float)sum;
}

//---------------------------------------------------------------------
// 0`255ɖOa
//---------------------------------------------------------------------
inline int satura8bit( int a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// tH_I_CAÕR[obN
//---------------------------------------------------------------------
int CALLBACK BrowseCallbackProc( HWND hwnd, UINT umsg, LPARAM lParam, LPARAM lpData )
{
    if( umsg == BFFM_INITIALIZED )
    {
        SendMessage( hwnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData );
    }
    return 0;
}

//---------------------------------------------------------------------
// tH_I_CAO
//---------------------------------------------------------------------
BOOL folderDialog( HWND hdlg, char *path )
{
    BROWSEINFO  binfo;
    ITEMIDLIST *lpidlist = NULL;
    LPMALLOC pMalloc = NULL;

    if( SHGetMalloc( &pMalloc ) == E_FAIL ) goto NO_GOOD;

    memset( &binfo, 0, sizeof( BROWSEINFO ) );
    binfo.hwndOwner      = hdlg;
    binfo.pszDisplayName = path;
    binfo.lpszTitle      = "ۑtH_̎w";
    binfo.ulFlags        = BIF_USENEWUI | BIF_RETURNONLYFSDIRS;
    binfo.lpfn           = &BrowseCallbackProc;
    binfo.lParam         = (LPARAM)path; //R[obNɓn

    lpidlist = SHBrowseForFolder( &binfo );
    if( lpidlist == NULL ) goto NO_GOOD;
    if( SHGetPathFromIDList( lpidlist, path ) == FALSE ) goto NO_GOOD;
    if( path[ strlen( path ) - 1 ] != '\\' ) strcat( path, "\\" );

    if( pMalloc )
    {
        if( lpidlist ) pMalloc->Free( lpidlist );
        pMalloc->Release();
    }
    return TRUE;

NO_GOOD:
    if( pMalloc )
    {
        if( lpidlist ) pMalloc->Free( lpidlist );
        pMalloc->Release();
    }
    return FALSE;
}

//---------------------------------------------------------------------
// ݒ_CAOProc
//---------------------------------------------------------------------
LRESULT CALLBACK dlg_config_proc( HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam )
{
    switch( umsg )
    {
        case WM_INITDIALOG: // ݒ_CAO
        {
            SetWindowText( hdlg, g_config_caption );
            SetDlgItemText( hdlg, IDC_PATH, config.path );
            HWND hBar = GetDlgItem( hdlg, IDC_QUALITY );                    // kĩo[
            SendMessage( hBar, TBM_SETRANGE, TRUE, MAKELPARAM(0, 100) );    // Ww
            SendMessage( hBar, TBM_SETTICFREQ, 10, 0 );                     // ڐ̑
            SendMessage( hBar, TBM_SETPAGESIZE, 0, 10 );                    // NbN̈ړ
            SendMessage( hBar, TBM_SETPOS, TRUE, config.qualty );           // ʒu̐ݒ
            TCHAR str[256];
            wsprintf( str, "ki %d", config.qualty );
            SetWindowText( GetDlgItem(hdlg, IDC_TEXT_QUALITY), (LPCTSTR)str );
            CheckDlgButton( hdlg, IDC_OPTIMIZE, config.optimize ? BST_CHECKED : BST_UNCHECKED );
            CheckDlgButton( hdlg, IDC_BEEP, config.beep ? BST_CHECKED : BST_UNCHECKED );
            CheckDlgButton( hdlg, IDC_PROGRESSION, config.progression ? BST_CHECKED : BST_UNCHECKED );
            CheckDlgButton( hdlg, IDC_PROGRESSION_MINE, config.progression_mine ? BST_CHECKED : BST_UNCHECKED );
            EnableWindow( GetDlgItem( hdlg, IDC_PROGRESSION_MINE ), config.progression ? TRUE : FALSE );
            // _ETvOiTuTvOj
            switch( config.downsampling )
            {
                case 0:  CheckDlgButton( hdlg, IDC_DOWN_YUV444,  BST_CHECKED ); break;
                case 1:  CheckDlgButton( hdlg, IDC_DOWN_YUV422,  BST_CHECKED ); break;
                case 3:  CheckDlgButton( hdlg, IDC_DOWN_GRAY,    BST_CHECKED ); break;
                case 4:  CheckDlgButton( hdlg, IDC_DOWN_YUV422v, BST_CHECKED ); break;
                case 5:  CheckDlgButton( hdlg, IDC_DOWN_YUV811h, BST_CHECKED ); break;
                case 6:  CheckDlgButton( hdlg, IDC_DOWN_YUV811v, BST_CHECKED ); break;
                default: CheckDlgButton( hdlg, IDC_DOWN_YUV411,  BST_CHECKED ); break;
            }
            // ʎqe[u
            switch( config.quantize )
            {
                case 1:  CheckDlgButton( hdlg, IDC_QUANT1, BST_CHECKED ); break;
                case 2:  CheckDlgButton( hdlg, IDC_QUANT2, BST_CHECKED ); break;
                default: CheckDlgButton( hdlg, IDC_QUANT0, BST_CHECKED ); break;
            }
            // AviUtl̐F
            switch( config.colormatrix )
            {
                case 1:  CheckDlgButton( hdlg, IDC_COLORMATRIX1, BST_CHECKED ); break;
                default: CheckDlgButton( hdlg, IDC_COLORMATRIX0, BST_CHECKED ); break;
            }

            return TRUE;
        }

        case WM_HSCROLL:
        {
            TCHAR str[256];
            HWND hBar_quality       = GetDlgItem( hdlg, IDC_QUALITY );
            HWND hBar_chroma_offset = GetDlgItem( hdlg, IDC_CHROMA_OFFSET );
            if( hBar_quality == (HWND)lparam )
            {
                int pos = SendMessage( hBar_quality, TBM_GETPOS, 0, 0 );  // ݂̒l̎擾
                wsprintf( str, "ki %d", pos );
                SetWindowText( GetDlgItem(hdlg, IDC_TEXT_QUALITY), (LPCTSTR)str );
                return TRUE;
            }
            else if( hBar_chroma_offset == (HWND)lparam )
            {
                int pos = SendMessage( hBar_chroma_offset, TBM_GETPOS, 0, 0 );  // ݂̒l̎擾
                wsprintf( str, "Fki␳ %d", pos );
                SetWindowText( GetDlgItem(hdlg, IDC_TEXT_CHROMA_OFFSET), (LPCTSTR)str );
                return TRUE;
            }
            break;
        }

        case WM_COMMAND:
        {
            switch( LOWORD(wparam) )
            {
                case IDCANCEL:
                    ShowWindow( g_hdlg, SW_HIDE );
                    return TRUE;

                case IDC_BUTTON_APPLY:
                case IDOK:
                    GetDlgItemText( hdlg, IDC_PATH, config.path, sizeof(config.path) );                             // pX
                    config.qualty           = SendMessage( GetDlgItem( hdlg,  IDC_QUALITY ), TBM_GETPOS, 0, 0 );    // ki
                    config.optimize         = IsDlgButtonChecked( hdlg, IDC_OPTIMIZE ) ? 1 : 0;                     // œK
                    config.beep             = IsDlgButtonChecked( hdlg, IDC_BEEP ) ? 1 : 0;                         // r[v
                    config.progression      = IsDlgButtonChecked( hdlg, IDC_PROGRESSION ) ? 1 : 0;                  // vObVu
                    config.progression_mine = IsDlgButtonChecked( hdlg, IDC_PROGRESSION_MINE ) ? 1 : 0;             // uJX^łgv

                    // _ETvOiTuTvOj
                    if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV444 ) )
                    {
                        config.downsampling = 0;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV422 ) )
                    {
                        config.downsampling = 1;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_GRAY ) )
                    {
                        config.downsampling = 3;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV422v ) )
                    {
                        config.downsampling = 4;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV811h ) )
                    {
                        config.downsampling = 5;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV811v ) )
                    {
                        config.downsampling = 6;
                    }
                    else
                    {
                        config.downsampling = 2;
                    }
                    // ʎqe[u
                    if( IsDlgButtonChecked( hdlg, IDC_QUANT1 ) )
                    {
                        config.quantize = 1;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_QUANT2 ) )
                    {
                        config.quantize = 2;
                    }
                    else
                    {
                        config.quantize = 0;
                    }
                    // AviUtl̐F
                    if( IsDlgButtonChecked( hdlg, IDC_COLORMATRIX1 ) )
                    {
                        config.colormatrix = 1;
                    }
                    else
                    {
                        config.colormatrix = 0;
                    }

                    if( IDOK == LOWORD(wparam) )
                    {
                        ShowWindow( g_hdlg, SW_HIDE );
                    }
                    return TRUE;

                case IDC_BUTTON_PATH: // ۑtH_ݒ
                {
                    char buff[MAX_PATH];
                    strncpy( buff, config.path, sizeof(buff) );
                    if( folderDialog( hdlg, buff ) )
                    {
                        SetDlgItemText( hdlg, IDC_PATH, buff );
                        return TRUE;
                    }
                    break;
                }

                case IDC_PROGRESSION: // vObVuuJX^łgv
                {
                    EnableWindow( GetDlgItem( hdlg, IDC_PROGRESSION_MINE ), IsDlgButtonChecked( hdlg, IDC_PROGRESSION ) ? TRUE : FALSE );
                    break;
                }

            }
            break;
        }

        case WM_CLOSE:
        {
            ShowWindow( g_hdlg, SW_HIDE );
            return TRUE;
        }

    }

    return FALSE;
}


//---------------------------------------------------------------------
// WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
    // TRUEԂƑŜĕ`悳炵

    switch( message )
    {
        case WM_FILTER_MAIN_MOVESIZE:
        {
            // KvȃNCAg̈̑傫𓾂邽߂ɃEChETCYύX
            RECT rect = {0, 0, CLIENT_WIDTH, CLIENT_HEIGHT};
            AdjustWindowRectEx( &rect, WS_CAPTION | WS_SYSMENU, FALSE, 0 );
            SetWindowPos( hwnd, NULL, 0, 0, rect.right - rect.left, rect.bottom - rect.top, SWP_NOMOVE | SWP_NOZORDER );
            break;
        }

        case WM_FILTER_INIT:
        {
            // {^zu
            HWND hprint = CreateWindow(
                TEXT("BUTTON"), "݂̃t[JPEGۑ",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | WS_TABSTOP,
                0, 0, PRINT_BUTTON_WIDTH, CLIENT_HEIGHT,
                hwnd, (HMENU)IDC_PRINT, fp->dll_hinst, NULL);
            SendMessage( hprint, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE );
            HWND hconfig = CreateWindow(
                TEXT("BUTTON"), "ݒ",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON | WS_TABSTOP,
                PRINT_BUTTON_WIDTH, 0, CONFIG_BUTTON_WIDTH, CLIENT_HEIGHT,
                hwnd, (HMENU)IDC_CONFIG, fp->dll_hinst, NULL);
            SendMessage( hconfig, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE );

            // iniǂ
            fp->exfunc->ini_load_str( fp, (LPSTR)"path", config.path, (LPSTR)config.path );
            config.qualty           = fp->exfunc->ini_load_int( fp, (LPSTR)"qualty",           config.qualty );
            config.optimize         = fp->exfunc->ini_load_int( fp, (LPSTR)"optimize",         config.optimize );
            config.progression      = fp->exfunc->ini_load_int( fp, (LPSTR)"progression",      config.progression );
            config.downsampling     = fp->exfunc->ini_load_int( fp, (LPSTR)"downsampling",     config.downsampling );
            config.quantize         = fp->exfunc->ini_load_int( fp, (LPSTR)"quantize",         config.quantize );
            config.beep             = fp->exfunc->ini_load_int( fp, (LPSTR)"beep",             config.beep );
            config.colormatrix      = fp->exfunc->ini_load_int( fp, (LPSTR)"colormatrix",      config.colormatrix );
            config.progression_mine = fp->exfunc->ini_load_int( fp, (LPSTR)"progression_mine", config.progression_mine );
            //config.chroma_offset    = fp->exfunc->ini_load_int( fp, (LPSTR)"chroma_offset",    config.chroma_offset );
            config.chroma_offset = 0;

            // config.path ȂJgpXݒ
            if( config.path[0] == '\0' )
            {
                GetCurrentDirectory( MAX_PATH, config.path );
                if( config.path[ strlen( config.path ) - 1 ] != '\\' ) strcat( config.path, "\\" );
            }

            // ݒ_CAO
            g_hdlg = CreateDialog( fp->dll_hinst, "CONFIG", hwnd, (DLGPROC)dlg_config_proc );

            return TRUE;
        }

        case WM_FILTER_SAVE_START: // ۑ{^𖳌
            EnableWindow( GetDlgItem( hwnd, IDC_PRINT ), FALSE );
            return TRUE;

        case WM_FILTER_SAVE_END: // ۑ{^L
            if( NoErr ) EnableWindow( GetDlgItem( hwnd, IDC_PRINT ),  TRUE );
            return TRUE;

        case WM_FILTER_EXIT:
        {
            // iniɕۑ
            fp->exfunc->ini_save_str( fp, (LPSTR)"path", (LPSTR)config.path );
            fp->exfunc->ini_save_int( fp, (LPSTR)"qualty",           config.qualty );
            fp->exfunc->ini_save_int( fp, (LPSTR)"optimize",         config.optimize );
            fp->exfunc->ini_save_int( fp, (LPSTR)"progression",      config.progression );
            fp->exfunc->ini_save_int( fp, (LPSTR)"downsampling",     config.downsampling );
            fp->exfunc->ini_save_int( fp, (LPSTR)"quantize",         config.quantize );
            fp->exfunc->ini_save_int( fp, (LPSTR)"beep",             config.beep );
            fp->exfunc->ini_save_int( fp, (LPSTR)"colormatrix",      config.colormatrix );
            fp->exfunc->ini_save_int( fp, (LPSTR)"progression_mine", config.progression_mine );
            //fp->exfunc->ini_save_int( fp, (LPSTR)"chroma_offset",    config.chroma_offset );

            DestroyWindow( g_hdlg );

            break;
        }

        case WM_FILTER_COMMAND:
        case WM_COMMAND:
        {
            switch( LOWORD(wparam) )
            {
                case IDC_CONFIG: // ݒ_CAOI[v
                    ShowWindow( g_hdlg, SW_SHOW );
                    break;

                case IDC_PRINT: // ݂̃t[ۑĩtB^̃Cj
                {
                    if( !NoErr ) goto NO_GOOD;
                    if( fp->exfunc->is_editing( editp ) != TRUE ) return FALSE; // ݕҏWłȂ̂ȂI


                    // ݂̃t[YC48ŃLbV
                    int frame = fp->exfunc->get_frame( editp ); // ݕ\̃t[ԍ擾
                    int w, h;
                    fp->exfunc->get_pixel_filtered_ex( editp, frame, NULL, &w, &h, 0 ); // t[̃TCY擾
                    fp->exfunc->set_ycp_filtering_cache_size( fp, w, h, 1, 0 ); // LbVݒ
                    PIXEL_YC *cache = fp->exfunc->get_ycp_filtering_cache_ex( fp, editp, frame, &w, &h ); // LbV擾

                    // JPEGIuWFNg̏
                    struct jpeg_compress_struct cinfo;
                    struct jpeg_error_mgr jerr;
                    if( NoErr ) cinfo.err = jpeg_std_error( &jerr );
                    jerr.error_exit = my_error_exit;
                    if( NoErr ) jpeg_create_compress( &cinfo );
                    cinfo.input_components = ( config.downsampling == 3 ) ? 1 : 3;
                    cinfo.in_color_space = ( config.downsampling == 3 ) ? JCS_GRAYSCALE : JCS_YCbCr; // J[Xy[Xjpeg_set_defaults̑OɎw
                    if( NoErr ) jpeg_set_defaults( &cinfo );
                    cinfo.image_width = w;
                    cinfo.image_height = h;
                    if( !NoErr ) goto NO_GOOD;
                    // _ETvOݒ
                    cinfo.comp_info[1].h_samp_factor = 1;
                    cinfo.comp_info[1].v_samp_factor = 1;
                    cinfo.comp_info[2].h_samp_factor = 1;
                    cinfo.comp_info[2].v_samp_factor = 1;
                    switch( config.downsampling )
                    {
                        case 0: // 4:4:4(4x4)
                            cinfo.comp_info[0].h_samp_factor = 1;
                            cinfo.comp_info[0].v_samp_factor = 1;
                            break;
                        case 1: // 4:2:2(2x1)
                            cinfo.comp_info[0].h_samp_factor = 2;
                            cinfo.comp_info[0].v_samp_factor = 1;
                            break;
                        case 4: // 4:2:2(1x2)
                            cinfo.comp_info[0].h_samp_factor = 1;
                            cinfo.comp_info[0].v_samp_factor = 2;
                            break;
                        case 5: // 8:1:1(4x2)
                            cinfo.comp_info[0].h_samp_factor = 4;
                            cinfo.comp_info[0].v_samp_factor = 2;
                            break;
                        case 6: // 8:1:1(2x4)
                            cinfo.comp_info[0].h_samp_factor = 2;
                            cinfo.comp_info[0].v_samp_factor = 4;
                            break;
                        case 2: // 4:2:0(2x2)
                        default:
                            cinfo.comp_info[0].h_samp_factor = 2;
                            cinfo.comp_info[0].v_samp_factor = 2;
                            break;
                    }
                    // kiʎqe[u
                    int quantize = config.quantize;
                    int chroma_offse = config.chroma_offset; // pɍ
                    chroma_offse = 0; // pɍgĂȂ̂ŔÔ0ɂ
                    if( quantize >= 0 && quantize <= 2 )
                    {
                        int qualty = jpeg_quality_scaling( config.qualty );
                        jpeg_add_quant_table( &cinfo, 0, my_quant_tbl[ quantize ][0], qualty, TRUE );
                        qualty = jpeg_quality_scaling( config.qualty + chroma_offse );
                        jpeg_add_quant_table( &cinfo, 1, my_quant_tbl[ quantize ][1], qualty, TRUE );
                    }
                    else
                    {
                        jpeg_set_quality( &cinfo, config.qualty, TRUE );
                    }
                    // vObVuݒ
                    if( config.progression && NoErr )
                    {
                        if( config.progression_mine )
                        {
                            my_jpeg_progression( &cinfo, 1 );// JX^
                        }
                        else
                        {
                            jpeg_simple_progression( &cinfo ); // ʏ
                        }
                    }
                    // œKIvVivObVuł͌ON̂͂j
                    if( config.optimize ) cinfo.optimize_coding = TRUE;

                    // Cobt@m
                    JSAMPROW line_buff = (JSAMPROW)malloc( sizeof( JSAMPLE ) * w * cinfo.input_components );
                    if( line_buff == NULL ) {
                        if( NoErr ) jpeg_destroy_compress( &cinfo );
                        return FALSE;
                    }

                    // t@C쐬
                    TCHAR path[MAX_PATH*2], filename[MAX_PATH*2]; // ]TMAX_PATH*2ɂĂ
                    struct timeval tv;
                    gettimeofday( &tv, NULL );
                    struct tm *local = localtime( &tv.tv_sec );
                    strncpy( path, config.path, sizeof(path) );
                    path[sizeof(path)-1] = '\0';
                    wsprintf( filename,  "%s%04d%02d%02d-%02d%02d%02d-%03d.jpg", path, local->tm_year + 1900,  local->tm_mon + 1, local->tm_mday, local->tm_hour, local->tm_min, local->tm_sec,  (int)(tv.tv_usec/1000) );

                    // t@CI[v
                    FILE *outfile = fopen( filename, "wb" );
                    if( outfile == NULL )
                    {
                        if( NoErr ) jpeg_destroy_compress( &cinfo );
                        free( line_buff );
                        return FALSE;
                    }
                    if( NoErr ) jpeg_stdio_dest( &cinfo, outfile );
                    if( NoErr ) jpeg_start_compress( &cinfo, TRUE ); // Jn
                    // 1Ck
                    for( int y = 0; y < h; y++ )
                    {
                        if( !NoErr ) break;
                        PIXEL_YC *ycp = cache + w * y;
                        if( config.downsampling == 3 ) // OCXP[Ȃ
                        {
                            if( config.colormatrix == 1 )
                            {
                                // AviUtlBT.709x[XȂ̂
                                // YC48BT.601ɕϊYCbCr(tW)ɕϊ
                                // Px݂̂ŃO[XP[ɂȂ
                                for( int x = 0; x < w; x++ )
                                {
                                    int Y = (int)ycp[x].y;
                                    int U = (int)ycp[x].cb;
                                    int V = (int)ycp[x].cr;
                                    line_buff[x] = satura8bit( ((Y * 4080 + U *  418 + V *  800 + 32768) >> 16) +   0 );
                                }
                            }
                            else
                            {
                                // Px݂̂ŃO[XP[ɂȂ
                                for( int x = 0; x < w; x++ )
                                {
                                    int Y = (int)ycp[x].y;
                                    line_buff[x] = satura8bit( (Y * 255 + 2048) >> 12 );
                                }
                            }
                        }
                        else
                        {
                            if( config.colormatrix == 1 )
                            {
                                // AviUtlBT.709x[XȂ
                                // YC48BT.601ɕϊYCbCr(tW)ɕϊ
                                for( int x = 0; x < w; x++ )
                                {
                                    int Y = (int)ycp[x].y;
                                    int U = (int)ycp[x].cb;
                                    int V = (int)ycp[x].cr;
                                    line_buff[3*x+0] = satura8bit( ((Y * 4080 + U *  418 + V *  800 + 32768) >> 16) +   0 );
                                    line_buff[3*x+1] = satura8bit( ((           U * 4023 + V * -450 + 32768) >> 16) + 128 );
                                    line_buff[3*x+2] = satura8bit( ((           U * -297 + V * 3996 + 32768) >> 16) + 128 );
                                }
                            }
                            else
                            {
                                // YC48YCbCr(tW)ɕϊ
                                for( int x = 0; x < w; x++ )
                                {
                                    int Y = (int)ycp[x].y;
                                    int U = (int)ycp[x].cb;
                                    int V = (int)ycp[x].cr;
                                    line_buff[3*x+0] = satura8bit( ((Y * 255 + 2048) >> 12) +   0 );
                                    line_buff[3*x+1] = satura8bit( ((U * 127 + 1024) >> 11) + 128 );
                                    line_buff[3*x+2] = satura8bit( ((V * 127 + 1024) >> 11) + 128 );
                                }
                            }
                        }

                        jpeg_write_scanlines( &cinfo, &line_buff, 1 );
                    }
                    if( NoErr ) jpeg_finish_compress( &cinfo );
                    if( NoErr ) jpeg_destroy_compress( &cinfo );
                    fclose( outfile );
                    free( line_buff );
                    if( !NoErr ) goto NO_GOOD;

                    fp->exfunc->set_ycp_filtering_cache_size( fp, w, h, 0, 0 ); // ŃLbVjH

                    if( config.beep ) MessageBeep( MB_ICONASTERISK ); // r[v
                    Sleep( 10 ); // 0.010bx݁iAˋ֎~̂߁j
                    break;
                }
            }
            break;
        }

    }
    return FALSE;

NO_GOOD:
    {
        // G[ꍇ͎gpsɂĂ
        MessageBeep( MB_ICONHAND );
        SetWindowText( hwnd, (LPCTSTR)"G[̂ߎgpsł" );
        EnableWindow( GetDlgItem( hwnd, IDC_PRINT ), FALSE );
        EnableWindow( GetDlgItem( hwnd, IDC_CONFIG ), FALSE );
        return FALSE;
    }
}
